<?

/*************************************************************************/
/*                                                                       */
/*  NetworkLens                                                          */
/*  Copyright (C) 2002, I-Link Incorporated                              */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License as       */
/*  published by the Free Software Foundation; either version 2 of the   */
/*  License, or (at your option) any later version.                      */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*  GNU General Public License for more details.                         */
/*                                                                       */
/*  You should have received a copy of the GNU General Public License    */
/*  along with this program; if not, write to the Free Software          */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            */
/*                                                                       */
/*  Detail Screen                                                        */
/*                                                                       */
/*  Change Log:                                                          */
/*                                                                       */
/*  2001/12/13  GEB  Initial script                                      */
/*  2002/01/15  GEB  Clean up                                            */
/*  2002/01/21  GEB  Add hostname next to IP address                     */
/*  2002/02/20  GEB  Add link for raw trap information if available      */
/*  2002/02/20  GEB  Fix SQL insert for lens_log table                   */
/*                                                                       */
/*************************************************************************/

require_once( "common.php" );

include('adodb/adodb.inc.php');
$conn = &ADONewConnection( $dbtype );
$conn->PConnect( $dbhost, $dbuser, $dbpass, $dbname );

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

/*************************************************************************/
/*                                                                       */
/*  If the user is not logged in, send them to the login screen to be    */
/*  authenticated; else, show the detail screen.                         */
/*                                                                       */
/*************************************************************************/

if ( ! is_logged_in() )
{
  $SESSION["return_url"] = $REQUEST_URI;
  header( "Location: login.php" );
}
else
{

?>

<HTML>

<HEAD>
<TITLE>NetworkLens Event Detail</TITLE>
<LINK REL=StyleSheet HREF="style.css" TYPE="text/css">
</HEAD>

<BODY>

<?
include('header.php');
?>

<?
if ( ! isset( $id ) )
{
  include('footer.php');
  printf( "</BODY></HTML>\n" );
  return;
}
?>

<CENTER>

<?
$recordSet = &$conn->Execute( 'select status, long_desc from lens_status' );
while ( ! $recordSet->EOF )
{
  $lens_status[$recordSet->fields["status"]] = $recordSet->fields["long_desc"];
  $recordSet->MoveNext();
}

/*************************************************************************/
/*                                                                       */
/*  If a form has been submitted, update the lens_event and lens_log     */
/*  tables and redraw the detail screen.                                 */
/*                                                                       */
/*************************************************************************/

if ( isset( $new_status ) )
{

  if ( $old_status != $new_status )
  {
    $temp_log = sprintf( "*** Status changed from %s to %s ***<br>", $lens_status[$old_status], $lens_status[$new_status] );
    $log = $temp_log . $log;
  }

  $sql_query = sprintf( "update lens_event set status = %d, modified = now() where id = %d", $new_status, $id );
  $recordSet = &$conn->Execute( $sql_query );

  $sql_query = sprintf( "insert into lens_log "
                      . "  ( id, modified, user, trap_id, log ) "
                      . "values ( %d, now(), '%s', NULL, '%s' )",
                        $id, $SESSION["user"], $log );

  $recordSet = &$conn->Execute( $sql_query );

  $msg = "Update successful";
}


$sql = "select lens_status.long_desc status, "
     . "       lens_event.status status_id, "
     . "       lens_severity.long_desc severity, "
     . "       created, "
     . "       modified, "
     . "       ip_addr, "
     . "       ref_id, "
     . "       category, "
     . "       summary, "
     . "       lens_severity.color "
     . "  from lens_event, lens_status, lens_severity "
     . " where id = $id "
     . "   and lens_event.status = lens_status.status "
     . "   and lens_event.severity = lens_severity.severity";

$recordSet = &$conn->Execute( $sql );

if ( $recordSet->EOF )
{
  include('footer.php');
  printf( "</BODY></HTML>\n" );
  return;
}

$old_status = $recordSet->fields["status_id"];

printf( "<FORM>\n" );
printf( "<TABLE WIDTH=\"100%%\" BORDER=0 CELLPADDING=10 CELLSPACING=0>\n" );
printf( "<TR>\n" );
printf( "<TD CLASS=nav WIDTH=\"30%%\" ALIGN=LEFT>Event %d (%s)</TD>\n", $id, $recordSet->fields["status"] );
if ( isset( $msg ) )
{
  printf( "<TD CLASS=nav-red WIDTH=\"40%%\" ALIGN=CENTER>%s</TD>\n", $msg );
}
else
{
  printf( "<TD CLASS=nav-red WIDTH=\"40%%\" ALIGN=CENTER>&nbsp;</TD>\n" );
}
printf( "<TD CLASS=nav WIDTH=\"30%%\" ALIGN=RIGHT>%s</TD>\n", gethostbyaddr( $recordSet->fields["ip_addr"] ) );
printf( "</TR>\n" );
printf( "</TABLE>\n" );
printf( "<BR>\n" );

printf( "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=3>\n" );

printf( "<TR><TD CLASS=detail-key>Severity:</TD>  <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["severity"] );
printf( "<TR><TD CLASS=detail-key>Created:</TD>   <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["created"] );
printf( "<TR><TD CLASS=detail-key>Modified:</TD>  <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["modified"] );
printf( "<TR><TD CLASS=detail-key>IP Address:</TD><TD CLASS=detail-value>%s (%s)</TD></TR>\n", $recordSet->fields["ip_addr"], gethostbyaddr( $recordSet->fields["ip_addr"] ) );
printf( "<TR><TD CLASS=detail-key>Ref ID:</TD>    <TD CLASS=detail-value>%d</TD></TR>\n", $recordSet->fields["ref_id"] );
printf( "<TR><TD CLASS=detail-key>Category:</TD>  <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["category"] );
printf( "<TR><TD CLASS=detail-key>Summary:</TD>   <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["summary"] );

printf( "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n" );

printf( "<TR><TD CLASS=detail-key>New Status:</TD><TD CLASS=detail-value>\n" );
printf( "<SELECT NAME=\"new_status\">\n" );
$selectSet = &$conn->Execute( 'select new_status, log_required from lens_status_change where old_status = "' . $old_status . '"' );
while ( ! $selectSet->EOF )
{
  printf( "<OPTION " );
  printf( "VALUE=\"%d\">%s",
          $selectSet->fields["new_status"],
          $lens_status[$selectSet->fields["new_status"]] );
  if ( $selectSet->fields["log_required"] )
  {
    printf( " (log entry required)" );
  }
  $selectSet->MoveNext();
}
printf( "</SELECT>\n" );
printf( "</TD></TR>\n" );

printf( "<TR><TD CLASS=detail-key>Add Log:</TD><TD CLASS=detail-value>\n" );
printf( "<TEXTAREA NAME=log WRAP=VIRTUAL ROWS=5 COLS=80></TEXTAREA>\n" );
printf( "</TD></TR>\n" );

printf( "</TABLE>\n" );
printf( "<BR>\n" );

printf( "<INPUT TYPE=\"SUBMIT\" VALUE=\"Update Event\">\n" );
printf( "<INPUT TYPE=\"HIDDEN\" NAME=id VALUE=%d>\n", $id );
printf( "<INPUT TYPE=\"HIDDEN\" NAME=old_status VALUE=%d>\n", $old_status );

printf( "</FORM>\n" );

/*************************************************************************/
/*                                                                       */
/*  Show the comment log.                                                */
/*                                                                       */
/*************************************************************************/

$recordSet = &$conn->Execute( "select id, modified, user, trap_id, log "
                            . "  from lens_log "
                            . " where id = $id "
                            . " order by modified desc" );

if ( ! $recordSet->EOF )
{
  printf( "<TABLE WIDTH=\"100%%\">\n" );
  printf( "<TR><TH>MODIFIED</TH><TH>USER ID</TH><TH WIDTH=\"100%%\">LOG</TH></TR>\n" );

  while ( ! $recordSet->EOF ) {
    printf( "<TR BGCOLOR=\"#FFC080\">" );
    printf( "<TD>%s</TD>", $recordSet->fields["modified"] );
    if ( isset( $recordSet->fields["trap_id"] ) )
    {
      printf( "<TD><A HREF=\"trapdetail.php?trap_id=%d\">%s</A></TD>",
              $recordSet->fields["trap_id"], $recordSet->fields["user"] );
    }
    else
    {
      printf( "<TD>%s</TD>", $recordSet->fields["user"] );
    }
    printf( "<TD>%s</TD>", $recordSet->fields["log"] );
    printf( "</TR>\n" );
    $recordSet->MoveNext();
  }

  printf( "</TABLE>\n" );
}

$selectSet->Close();
$recordSet->Close();
$conn->Close();
?>

</CENTER>

<?
include('footer.php');
?>

</BODY>
</HTML>

<?

}

/*************************************************************************/
/*                                                                       */
/*************************************************************************/

?>
