<?

/*************************************************************************/
/*                                                                       */
/*  NetworkLens                                                          */
/*  Copyright (C) 2002, I-Link Incorporated                              */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License as       */
/*  published by the Free Software Foundation; either version 2 of the   */
/*  License, or (at your option) any later version.                      */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*  GNU General Public License for more details.                         */
/*                                                                       */
/*  You should have received a copy of the GNU General Public License    */
/*  along with this program; if not, write to the Free Software          */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            */
/*                                                                       */
/*  Overview Screen                                                      */
/*                                                                       */
/*  Change Log:                                                          */
/*                                                                       */
/*  2001/12/13  GEB  Initial script                                      */
/*  2002/01/14  GEB  Clean up; use fetch-by-association                  */
/*  2002/01/21  GEB  Use fixed percentages for header bar                */
/*  2002/01/22  GEB  Show query name being used                          */
/*  2002/01/22  GEB  Actually filter event list by the query used        */
/*                                                                       */
/*************************************************************************/

require_once( "common.php" );

include('adodb/adodb.inc.php');
$conn = &ADONewConnection( $dbtype );
$conn->PConnect( $dbhost, $dbuser, $dbpass, $dbname );

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

/*************************************************************************/
/*                                                                       */
/*  If the user is not logged in, send them to the login screen to be    */
/*  authenticated; else, show the high-level summary screen.             */
/*                                                                       */
/*************************************************************************/

if ( ! is_logged_in() )
{
  $SESSION["return_url"] = $REQUEST_URI;
  header( "Location: login.php" );
}
else
{

?>

<HTML>

<HEAD>
<TITLE>NetworkLens Overview</TITLE>
<LINK REL=StyleSheet HREF="style.css" TYPE="text/css">
</HEAD>

<BODY>

<?
include('header.php');
?>

<CENTER>
<TABLE WIDTH="100%">

<?
/*=---------------------------------------------------------------------=*/
/*=-  Try one of the following, until something works:                 -=*/
/*=-  1.  Use $SESSION["last_query"] query and $SESSION["user"] user   -=*/
/*=-  2.  Use $SESSION["last_query"] query and "SYSTEM" user           -=*/
/*=-  3.  Use "DEFAULT" query and "SYSTEM" user                        -=*/
/*=-  4.  Use no modifiers; select ALL events                          -=*/
/*=---------------------------------------------------------------------=*/

$sql = sprintf( "select status_b, status_val, severity_b, severity_val, "
              . "       created_min_b, created_min_val, created_max_b, created_max_val, "
              . "       modified_min_b, modified_min_val, modified_max_b, modified_max_val, "
              . "       ip_addr_b, ip_addr_qual, ip_addr_val, "
              . "       ref_id_b, ref_id_qual, ref_id_val, "
              . "       category_b, category_qual, category_val, "
              . "       summary_b, summary_qual, summary_val "
              . "  from lens_query "
              . " where query = '%s' "
              . "   and user = '%s'", $SESSION["last_query"], $SESSION["user"] );

$selectSet = &$conn->Execute( $sql );

if ( $selectSet->EOF )
{
  $sql = sprintf( "select status_b, status_val, severity_b, severity_val, "
                . "       created_min_b, created_min_val, created_max_b, created_max_val, "
                . "       modified_min_b, modified_min_val, modified_max_b, modified_max_val, "
                . "       ip_addr_b, ip_addr_qual, ip_addr_val, "
                . "       ref_id_b, ref_id_qual, ref_id_val, "
                . "       category_b, category_qual, category_val, "
                . "       summary_b, summary_qual, summary_val "
                . "  from lens_query "
                . " where query = '%s' "
                . "   and user = '%s'", $SESSION["last_query"], "SYSTEM" );

  $selectSet = &$conn->Execute( $sql );
}

if ( $selectSet->EOF )
{
  $sql = sprintf( "select status_b, status_val, severity_b, severity_val, "
                . "       created_min_b, created_min_val, created_max_b, created_max_val, "
                . "       modified_min_b, modified_min_val, modified_max_b, modified_max_val, "
                . "       ip_addr_b, ip_addr_qual, ip_addr_val, "
                . "       ref_id_b, ref_id_qual, ref_id_val, "
                . "       category_b, category_qual, category_val, "
                . "       summary_b, summary_qual, summary_val "
                . "  from lens_query "
                . " where query = '%s' "
                . "   and user = '%s'", "DEFAULT", "SYSTEM" );

  $selectSet = &$conn->Execute( $sql );
}

if ( $selectSet->EOF )
{
  $status_b       = 0;
  $severity_b     = 0;
  $created_min_b  = 0;
  $created_max_b  = 0;
  $modified_min_b = 0;
  $modified_max_b = 0;
  $ip_addr_b      = 0;
  $ref_id_b       = 0;
  $category_b     = 0;
  $summary_b      = 0;
}
else
{
  $status_b = $selectSet->fields["status_b"];
  $status_val = $selectSet->fields["status_val"];
  $severity_b = $selectSet->fields["severity_b"];
  $severity_val = $selectSet->fields["severity_val"];
  $created_min_b = $selectSet->fields["created_min_b"];
  $created_min_val = $selectSet->fields["created_min_val"];
  $created_max_b = $selectSet->fields["created_max_b"];
  $created_max_val = $selectSet->fields["created_max_val"];
  $modified_min_b = $selectSet->fields["modified_min_b"];
  $modified_min_val = $selectSet->fields["modified_min_val"];
  $modified_max_b = $selectSet->fields["modified_max_b"];
  $modified_max_val = $selectSet->fields["modified_max_val"];
  $ip_addr_b = $selectSet->fields["ip_addr_b"];
  $ip_addr_qual = $selectSet->fields["ip_addr_qual"];
  $ip_addr_val = $selectSet->fields["ip_addr_val"];
  $ref_id_b = $selectSet->fields["ref_id_b"];
  $ref_id_qual = $selectSet->fields["ref_id_qual"];
  $ref_id_val = $selectSet->fields["ref_id_val"];
  $category_b = $selectSet->fields["category_b"];
  $category_qual = $selectSet->fields["category_qual"];
  $category_val = $selectSet->fields["category_val"];
  $summary_b = $selectSet->fields["summary_b"];
  $summary_qual = $selectSet->fields["summary_qual"];
  $summary_val = $selectSet->fields["summary_val"];
}

$sql  = '  select id, '
      . '         lens_status.long_desc status, '
      . '         lens_severity.long_desc severity, '
      . '         created, '
      . '         modified, '
      . '         ip_addr, '
      . '         ref_id, '
      . '         category, '
      . '         summary, '
      . '         lens_severity.color '
      . '    from lens_event, lens_status, lens_severity '
      . '   where lens_event.status = lens_status.status '
      . '     and lens_event.severity = lens_severity.severity ';

if ( $status_b )                          $sql .= sprintf( "and lens_event.status in (%s) ", $status_val );
if ( $severity_b )                        $sql .= sprintf( "and lens_event.severity in (%s) ", $severity_val );
if ( $created_min_b )                     $sql .= sprintf( "and created >= '%s' ", $created_min_val );
if ( $created_max_b )                     $sql .= sprintf( "and created <= '%s' ", $created_max_val );
if ( $modified_min_b )                    $sql .= sprintf( "and modified >= '%s' ", $modified_min_val );
if ( $modified_max_b )                    $sql .= sprintf( "and modified <= '%s' ", $modified_max_val );
if ( $ip_addr_b )
{
  if     ( $ip_addr_qual == "=" )         $sql .= sprintf( "and ip_addr = '%s' ", $ip_addr_val );
  elseif ( $ip_addr_qual == "LIKE" )      $sql .= sprintf( "and ip_addr like '%s' ", $ip_addr_val );
  elseif ( $ip_addr_qual == "IN" )        $sql .= sprintf( "and ip_addr in (%s) ", $ip_addr_val );
  elseif ( $ip_addr_qual == "NOT LIKE" )  $sql .= sprintf( "and ip_addr not like '%s' ", $ip_addr_val );
  elseif ( $ip_addr_qual == "NOT IN" )    $sql .= sprintf( "and ip_addr not in (%s) ", $ip_addr_val );
}
if ( $ref_id_b )
{
  if     ( $ref_id_qual == "=" )          $sql .= sprintf( "and ref_id = %s ", $ref_id_val );
  elseif ( $ref_id_qual == "IN" )         $sql .= sprintf( "and ref_id in (%s) ", $ref_id_val );
  elseif ( $ref_id_qual == "NOT IN" )     $sql .= sprintf( "and ref_id not in (%s) ", $ref_id_val );
}
if ( $category_b )
{
  if     ( $category_qual == "=" )        $sql .= sprintf( "and category = '%s' ", $category_val );
  elseif ( $category_qual == "LIKE" )     $sql .= sprintf( "and category like '%s' ", $category_val );
  elseif ( $category_qual == "IN" )       $sql .= sprintf( "and category in (%s) ", $category_val );
  elseif ( $category_qual == "NOT LIKE" ) $sql .= sprintf( "and category not like '%s' ", $category_val );
  elseif ( $category_qual == "NOT IN" )   $sql .= sprintf( "and category not in (%s) ", $category_val );
}
if ( $summary_b )
{
  if     ( $summary_qual == "=" )         $sql .= sprintf( "and summary = '%s' ", $summary_val );
  elseif ( $summary_qual == "LIKE" )      $sql .= sprintf( "and summary like '%s' ", $summary_val );
  elseif ( $summary_qual == "IN" )        $sql .= sprintf( "and summary in (%s) ", $summary_val );
  elseif ( $summary_qual == "NOT LIKE" )  $sql .= sprintf( "and summary not like '%s' ", $summary_val );
  elseif ( $summary_qual == "NOT IN" )    $sql .= sprintf( "and summary not in (%s) ", $summary_val );
}

$sql .= 'order by lens_event.status, '
      . '         lens_event.severity, '
      . '         id desc';

printf( "<!-- SQL: %s -->\n", $sql );  ## FIXME

$recordSet = &$conn->CacheExecute( $cache_timeout, $sql );

if ( isset( $HTTP_GET_VARS['start'] ) )
{
  $start_rec = $HTTP_GET_VARS['start'];
}
else
{
  $start_rec = 0;
}

/*************************************************************************/
/*                                                                       */
/*  Fix up values of start_rec to fit within the record range, and move  */
/*  it to the nearest multiple of results_per_page.                      */
/*                                                                       */
/*************************************************************************/

if ( $start_rec < 0 )
{
  $start_rec = 0;
}
else if ( $start_rec >= $recordSet->RecordCount() )
{
  $start_rec = $recordSet->RecordCount() - 1;
}

$start_rec = $start_rec - ( $start_rec % $results_per_page );

$start_page = (int)( $start_rec / $results_per_page ) + 1;

$total_pages = (int)( ( $recordSet->RecordCount() + $results_per_page - 1 ) / $results_per_page );
?>

<TR>
<TD COLSPAN=9>
<TABLE WIDTH="100%" BORDER=0 CELLPADDING=10 CELLSPACING=0>
<TR>
<TD CLASS=nav WIDTH="30%" ALIGN=LEFT>
<?
  if ( $total_pages > 0 )
  {
    printf( "Page %d of %d", $start_page, $total_pages );
  }
  else
  {
    printf( "No Matching Events" );
  }
?>
</TD>
<TD CLASS=nav WIDTH="40%" ALIGN=CENTER>
<A CLASS=nav HREF="<? echo $PHP_SELF, '?start=0' ?>">FIRST</A>
&nbsp;&nbsp;&nbsp;
<A CLASS=nav HREF="<? echo $PHP_SELF, '?start=', $start_rec - $results_per_page ?>">PREVIOUS</A>
&nbsp;&nbsp;&nbsp;
<A CLASS=nav HREF="<? echo $PHP_SELF, '?start=', $start_rec + $results_per_page ?>">NEXT</A>
&nbsp;&nbsp;&nbsp;
<A CLASS=nav HREF="<? echo $PHP_SELF, '?start=', $recordSet->RecordCount() - 1 ?>">LAST</A>
</TD>
<TD CLASS=nav WIDTH="30%" ALIGN=RIGHT>
<? echo $SESSION["last_query"], ' (', $recordSet->RecordCount(), ' Records)' ?>
</TD>
</TR>
</TABLE>
</TD>
</TR>

<TR>
<TH>ID</TH>
<TH>STATUS</TH>
<TH>SEVERITY</TH>
<TH>CREATED</TH>
<TH>MODIFIED</TH>
<TH>IP ADDR</TH>
<TH>REF ID</TH>
<TH>CATEGORY</TH>
<TH WIDTH="100%">SUMMARY</TH>
</TR>

<?
$recordSet->Move( $start_rec );

while ( ( ! $recordSet->EOF ) && ( $recordSet->CurrentRow() < $start_rec + $results_per_page ) )
{
  printf( "<tr bgcolor=\"%s\">", $recordSet->fields["color"] );
  printf( "<td><a href=\"detail.php?id=%d\">%d</a></td>", $recordSet->fields["id"], $recordSet->fields["id"] );
  printf( "<td>%s</td>", $recordSet->fields["status"] );
  printf( "<td>%s</td>", $recordSet->fields["severity"] );
  printf( "<td>%s</td>", $recordSet->fields["created"] );
  if ( isset( $recordSet->fields["modified"] ) )
  {
    printf( "<td>%s</td>", $recordSet->fields["modified"] );
  }
  else
  {
    printf( "<td></td>" );
  }
  printf( "<td>%s</td>", $recordSet->fields["ip_addr"] );
  printf( "<td>%d</td>", $recordSet->fields["ref_id"] );
  printf( "<td>%s</td>", $recordSet->fields["category"] );
  printf( "<td>%s</td>", $recordSet->fields["summary"] );
  printf( "</tr>\n" );

  $recordSet->MoveNext();
}

$recordSet->Close();
$conn->Close();
?>

</TABLE>
</CENTER>

<?
include('footer.php');
?>

</BODY>
</HTML>

<?

}

/*************************************************************************/
/*                                                                       */
/*************************************************************************/

?>
