<?

/*************************************************************************/
/*                                                                       */
/*  NetworkLens                                                          */
/*  Copyright (C) 2002, I-Link Incorporated                              */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License as       */
/*  published by the Free Software Foundation; either version 2 of the   */
/*  License, or (at your option) any later version.                      */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*  GNU General Public License for more details.                         */
/*                                                                       */
/*  You should have received a copy of the GNU General Public License    */
/*  along with this program; if not, write to the Free Software          */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            */
/*                                                                       */
/*  Password Management Screen                                           */
/*                                                                       */
/*  Change Log:                                                          */
/*                                                                       */
/*  2002/01/25  GEB  Initial script                                      */
/*  2002/02/21  GEB  Delete a user's queries when the user is removed    */
/*  2002/02/21  GEB  Recognize new "admin" field in lens_user to         */
/*                     determine if a user has admin privileges          */
/*  2002/02/21  GEB  Add admin flag to user creation/modification        */
/*                                                                       */
/*************************************************************************/

require_once( "common.php" );

include('adodb/adodb.inc.php');
$conn = &ADONewConnection( $dbtype );
$conn->PConnect( $dbhost, $dbuser, $dbpass, $dbname );

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

/*************************************************************************/
/*                                                                       */
/*  If the user is not logged in, send them to the login screen to be    */
/*  authenticated; else, show the detail screen.                         */
/*                                                                       */
/*************************************************************************/

if ( ! is_logged_in() )
{
  $SESSION["return_url"] = $REQUEST_URI;
  header( "Location: login.php" );
}
else
{

?>

<HTML>

<HEAD>
<TITLE>NetworkLens Password Management</TITLE>
<LINK REL=StyleSheet HREF="style.css" TYPE="text/css">
</HEAD>

<BODY>

<?
include('header.php');
?>

<CENTER>

<?
/*************************************************************************/
/*                                                                       */
/*  If a form has been submitted, process the request and redraw         */
/*  the form.                                                            */
/*                                                                       */
/*************************************************************************/

if ( isset( $action ) )
{
  if ( $action == "Create User" )
  {
    /*=-----------------------------------------------------------------=*/
    /*=-  Add the specified user ID                                    -=*/
    /*=-----------------------------------------------------------------=*/

    if ( $SESSION["admin"] != "1" )
    {
      $msg = "Not Authorized";
    }
    elseif ( $cre_newpassword != $cre_verifypassword )
    {
      $msg = "Passwords Do Not Match";
    }
    else
    {
      if ( ! isset( $cre_admin ) )
      {
        $cre_admin = "0";
      }

      $sql = sprintf( "insert into lens_user "
                    . "  ( user, admin, password, fullname, last_query ) "
                    . "values "
                    . "  ( '%s', %d, md5( '%s' ), '%s', 'DEFAULT' )",
                      $cre_userid, $cre_admin, $cre_newpassword, $cre_fullname );

      $selectSet = &$conn->Execute( $sql );

      if ( $selectSet === false )
      {
        $msg = sprintf( "Error inserting: %s<BR>\n", $conn->ErrorMsg() );
      }
      else
      {
        $msg = "User [" . $cre_userid . "] Created";
      }
    }
  }
  elseif ( $action == "Delete User" )
  {
    /*=-----------------------------------------------------------------=*/
    /*=-  Delete the specified user ID                                 -=*/
    /*=-----------------------------------------------------------------=*/

    if ( $SESSION["admin"] != "1" )
    {
      $msg = "Not Authorized";
    }
    else
    {
      $sql = sprintf( "delete from lens_query "
                    . " where user = '%s'", $del_userid );

      $selectSet = &$conn->Execute( $sql );

      $sql = sprintf( "delete from lens_user "
                    . " where user = '%s'", $del_userid );

      $selectSet = &$conn->Execute( $sql );

      if ( $selectSet === false )
      {
        $msg = sprintf( "Error deleting: %s<BR>\n", $conn->ErrorMsg() );
      }
      else
      {
        $msg = "User [" . $del_userid . "] Deleted";
      }
    }
  }
  elseif ( $action == "Modify User" )
  {
    /*=-----------------------------------------------------------------=*/
    /*=-  Modify the specified user ID                                 -=*/
    /*=-----------------------------------------------------------------=*/

    if ( $mod_newpassword == "" )
    {
      $msg = "No Password Specified";
    }
    elseif ( $mod_newpassword != $mod_verifypassword )
    {
      $msg = "Passwords Do Not Match";
    }
    else
    {
      if ( ! isset( $mod_admin ) )
      {
        $mod_admin = "0";
      }

      /*=---------------------------------------------------------------=*/
      /*=-  If not an administrator, force modification to be the      -=*/
      /*=-  user's own ID.                                             -=*/
      /*=---------------------------------------------------------------=*/

      if ( $SESSION["admin"] != "1" )
      {
        $mod_userid = $SESSION["user"];
        $mod_admin = 0;
      }

      $sql = sprintf( "update lens_user "
                    . "   set admin = %d, "
                    . "       password = md5( '%s' ), "
                    . "       fullname = '%s' "
                    . " where user = '%s'", $mod_admin, $mod_newpassword, $mod_fullname, $mod_userid );

      $selectSet = &$conn->Execute( $sql );

      if ( $selectSet === false )
      {
        $msg = sprintf( "Error updating: %s<BR>\n", $conn->ErrorMsg() );
      }
      else
      {
        $msg = "User [" . $mod_userid . "] Modified";
      }
    }
  }
  else
  {
    $msg = "Catastrophic ERROR!";
  }
}

/*************************************************************************/
/*                                                                       */
/*  Draw the HTML form                                                   */
/*                                                                       */
/*************************************************************************/

?>

<FORM>

<TABLE WIDTH="100%" BORDER=0 CELLPADDING=10 CELLSPACING=0><TR>
<TD CLASS=nav WIDTH="30%" ALIGN=LEFT>Password Management</TD>
<TD CLASS=nav-red WIDTH="40%" ALIGN=CENTER>
<? if ( isset( $msg ) ) { echo $msg; } else { echo '&nbsp;'; } ?></TD>
<TD CLASS=nav WIDTH="30%" ALIGN=RIGHT>&nbsp;</TD>
</TR></TABLE>

<BR>

<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=3>

<?
if ( $SESSION["admin"] == "1" )
{
?>

<TR><TD CLASS=detail-key>User ID:</TD>
<TD CLASS=detail-value><INPUT TYPE=text SIZE=30 NAME=cre_userid></TD>
<TD CLASS=detail-value ROWSPAN=5><INPUT TYPE=SUBMIT NAME=action VALUE="Create User"></TD></TR>
<TR><TD CLASS=detail-key>Administrator:</TD>
<TD CLASS=detail-value><INPUT TYPE=checkbox NAME=cre_admin VALUE="1"></TD>
<TR><TD CLASS=detail-key>Full Name:</TD>
<TD CLASS=detail-value><INPUT TYPE=text SIZE=30 NAME=cre_fullname></TD></TR>
<TR><TD CLASS=detail-key>New Password:</TD>
<TD CLASS=detail-value><INPUT TYPE=password SIZE=30 NAME=cre_newpassword></TD></TR>
<TR><TD CLASS=detail-key>Verify Password:</TD>
<TD CLASS=detail-value><INPUT TYPE=password SIZE=30 NAME=cre_verifypassword></TD></TR>

<TR><TD COLSPAN=3>&nbsp;</TD></TR>

<TR><TD CLASS=detail-key>User ID:</TD>
<TD CLASS=detail-value>
<SELECT NAME=del_userid>
<?
$sql = sprintf( "select user from lens_user where user != 'admin' order by user" );
$selectSet = &$conn->Execute( $sql );
while ( ! $selectSet->EOF )
{
  printf( "<OPTION>%s", $selectSet->fields["user"] );
  $selectSet->MoveNext();
}
?>
</SELECT>
</TD>
<TD CLASS=detail-value><INPUT TYPE=SUBMIT NAME=action VALUE="Delete User"></TD></TR>

<TR><TD COLSPAN=3>&nbsp;</TD></TR>

<?
}
?>

<TR><TD CLASS=detail-key>User ID:</TD>
<TD CLASS=detail-value>
<?
if ( $SESSION["admin"] == "1" )
{
  printf( "<SELECT NAME=mod_userid>\n" );
  $sql = sprintf( "select user from lens_user order by user" );
  $selectSet = &$conn->Execute( $sql );
  while ( ! $selectSet->EOF )
  {
    printf( "<OPTION>%s", $selectSet->fields["user"] );
    $selectSet->MoveNext();
  }
  printf( "</SELECT>\n" );
}
else
{
  echo $SESSION["user"];
}
?>
</TD>
<?
if ( $SESSION["admin"] == "1" )
{
  printf( "<TD CLASS=detail-value ROWSPAN=5><INPUT TYPE=SUBMIT NAME=action VALUE=\"Modify User\"></TD></TR>\n" );
  printf( "<TR><TD CLASS=detail-key>Administrator:</TD>\n" );
  printf( "<TD CLASS=detail-value><INPUT TYPE=checkbox NAME=mod_admin VALUE=\"1\"></TD>\n" );
}
else
{
  printf( "<TD CLASS=detail-value ROWSPAN=4><INPUT TYPE=SUBMIT NAME=action VALUE=\"Modify User\"></TD></TR>\n" );
}
?>
<TR><TD CLASS=detail-key>Full Name:</TD>
<TD CLASS=detail-value>
<?
if ( $SESSION["admin"] == "1" )
{
  printf( "<INPUT TYPE=text SIZE=30 NAME=mod_fullname>\n" );
}
else
{
  printf( "<INPUT TYPE=text SIZE=30 NAME=mod_fullname VALUE=\"%s\">\n", $SESSION["fullname"] );
}
?>
</TD></TR>
<TR><TD CLASS=detail-key>New Password:</TD>
<TD CLASS=detail-value><INPUT TYPE=password SIZE=30 NAME=mod_newpassword></TD></TR>
<TR><TD CLASS=detail-key>Verify Password:</TD>
<TD CLASS=detail-value><INPUT TYPE=password SIZE=30 NAME=mod_verifypassword></TD></TR>

</TABLE>

<BR>

<?
if ( $SESSION["admin"] == "1" )
{
?>

<TABLE WIDTH="100%" BORDER=0 CELLPADDING=10 CELLSPACING=0><TR>
<TD CLASS=nav WIDTH="30%" ALIGN=LEFT>User ID History</TD>
<TD CLASS=nav-red WIDTH="40%" ALIGN=CENTER>&nbsp;</TD>
<TD CLASS=nav WIDTH="30%" ALIGN=RIGHT>&nbsp;</TD>
</TR></TABLE>

<BR>

<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=3>
<TR>
<TD CLASS=trapdetail-key>User ID</TD>
<TD CLASS=trapdetail-key>Admin</TD>
<TD CLASS=trapdetail-key>Full Name</TD>
<TD CLASS=trapdetail-key>Last Login</TD>
<TD CLASS=trapdetail-key>Last Host IP</TD>
<TD CLASS=trapdetail-key>Last Host Name</TD>
<TD CLASS=trapdetail-key>Last Query</TD>
</TR>
<?
$sql = sprintf( "select user, admin, fullname, last_login, last_ip, last_query from lens_user order by user" );
$selectSet = &$conn->Execute( $sql );
while ( ! $selectSet->EOF )
{
  printf( "<TR>" );
  printf( "<TD CLASS=detail-value>%s&nbsp;</TD>", $selectSet->fields["user"] );
  if ( $selectSet->fields["admin"] == "1" )
  {
    printf( "<TD CLASS=detail-value>YES</TD>" );
  }
  else
  {
    printf( "<TD CLASS=detail-value>&nbsp;</TD>" );
  }
  printf( "<TD CLASS=detail-value>%s&nbsp;</TD>", $selectSet->fields["fullname"] );
  printf( "<TD CLASS=detail-value>%s&nbsp;</TD>", $selectSet->fields["last_login"] );
  printf( "<TD CLASS=detail-value>%s&nbsp;</TD>", $selectSet->fields["last_ip"] );
  printf( "<TD CLASS=detail-value>%s&nbsp;</TD>", gethostbyaddr( $selectSet->fields["last_ip"] ) );
  printf( "<TD CLASS=detail-value>%s&nbsp;</TD>", $selectSet->fields["last_query"] );
  printf( "</TR>\n" );
  $selectSet->MoveNext();
}
?>
</TABLE>

<BR>

<?
}
?>

</FORM>

<?
$selectSet->Close();
$conn->Close();
?>

</CENTER>

<?
include('footer.php');
?>

</BODY>
</HTML>

<?

}

/*************************************************************************/
/*                                                                       */
/*************************************************************************/

?>
