<?

/*************************************************************************/
/*                                                                       */
/*  NetworkLens                                                          */
/*  Copyright (C) 2002, I-Link Incorporated                              */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License as       */
/*  published by the Free Software Foundation; either version 2 of the   */
/*  License, or (at your option) any later version.                      */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*  GNU General Public License for more details.                         */
/*                                                                       */
/*  You should have received a copy of the GNU General Public License    */
/*  along with this program; if not, write to the Free Software          */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            */
/*                                                                       */
/*  Query Management Screen                                              */
/*                                                                       */
/*  Change Log:                                                          */
/*                                                                       */
/*  2001/12/13  GEB  Initial script                                      */
/*  2002/01/21  GEB  Clean up                                            */
/*  2002/01/22  GEB  Add NOT LIKE, NOT IN                                */
/*  2002/01/22  GEB  Remove addslashes() usage                           */
/*  2002/01/22  GEB  Redirect on "Execute" button                        */
/*  2002/01/22  GEB  Show current query in select bar                    */
/*  2002/01/24  GEB  Update last_notify when saving a query              */
/*  2002/02/20  GEB  Fix link to main screen on "Execute"                */
/*                                                                       */
/*************************************************************************/

require_once( "common.php" );

include('adodb/adodb.inc.php');
$conn = &ADONewConnection( $dbtype );
$conn->PConnect( $dbhost, $dbuser, $dbpass, $dbname );

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

/*************************************************************************/
/*                                                                       */
/*  If the user is not logged in, send them to the login screen to be    */
/*  authenticated; else, show the detail screen.                         */
/*                                                                       */
/*************************************************************************/

if ( ! is_logged_in() )
{
  $SESSION["return_url"] = $REQUEST_URI;
  header( "Location: login.php" );
}
elseif ( isset( $action ) && ( $action == "Execute" ) )
{
  /*=-------------------------------------------------------------------=*/
  /*=-  Set the current query as the default and redirect.             -=*/
  /*=-------------------------------------------------------------------=*/

  $SESSION["last_query"] = $query_pulldown;

  $result = &$conn->Execute( "UPDATE lens_user "
                           . "   SET last_query = '$query_pulldown' "
                           . " WHERE user = '" . $SESSION["user"] . "'" );

  $result->Close();
  $conn->Close();

  header( "Location: /" );
}
else
{

?>

<HTML>

<HEAD>
<TITLE>NetworkLens Query Management</TITLE>
<LINK REL=StyleSheet HREF="style.css" TYPE="text/css">
</HEAD>

<BODY>

<?
include('header.php');
?>

<CENTER>

<?
/*************************************************************************/
/*                                                                       */
/*  If a form has been submitted, process the query request and redraw   */
/*  the query screen.                                                    */
/*                                                                       */
/*************************************************************************/

if ( isset( $action ) )
{
  if ( $action == "Save/Update Query" )
  {
    $msg = "";

    /*=-----------------------------------------------------------------=*/
    /*=-  First try to remove the query, if it exists.                 -=*/
    /*=-----------------------------------------------------------------=*/

    $sql = sprintf( "delete "
                  . "  from lens_query "
                  . " where query = '%s' "
                  . "   and user = '%s'", $query, $SESSION["user"] );

    $selectSet = &$conn->Execute( $sql );

    if ( $selectSet === false )
    {
      $msg .= sprintf( "Error deleting: %s<BR>\n", $conn->ErrorMsg() );
    }

    /*=-----------------------------------------------------------------=*/
    /*=-  Clean up the status and severity lists.                      -=*/
    /*=-----------------------------------------------------------------=*/

    if ( ! isset( $status_val ) )
    {
      $status_val = "";
    }

    if ( ! isset( $severity_val ) )
    {
      $severity_val = "";
    }

    $status_val_list = "";
    for ( $i = 0; $i < count( $status_val ); $i++ )
    {
      $status_val_list .= ",";
      $status_val_list .= $status_val[$i];
    }
    if ( $status_val_list[0] == "," )
    {
      $status_val_list = substr( $status_val_list, 1 );
    }

    $severity_val_list = "";
    for ( $i = 0; $i < count( $severity_val ); $i++ )
    {
      $severity_val_list .= ",";
      $severity_val_list .= $severity_val[$i];
    }
    if ( $severity_val_list[0] == "," )
    {
      $severity_val_list = substr( $severity_val_list, 1 );
    }

    /*=-----------------------------------------------------------------=*/
    /*=-  Now try to insert the current values.                        -=*/
    /*=-----------------------------------------------------------------=*/

    $sql = sprintf( "insert into lens_query "
                  . "  ( user, query, "
                  . "    email_b, email_val, status_b, status_val, severity_b, severity_val, "
                  . "    created_min_b, created_min_val, created_max_b, created_max_val, "
                  . "    modified_min_b, modified_min_val, modified_max_b, modified_max_val, "
                  . "    ip_addr_b, ip_addr_qual, ip_addr_val, "
                  . "    ref_id_b, ref_id_qual, ref_id_val, "
                  . "    category_b, category_qual, category_val, "
                  . "    summary_b, summary_qual, summary_val, last_notify ) "
                  . "values "
                  . "  ( '%s', '%s', "
                  . "    %d, '%s', %d, '%s', %d, '%s', "
                  . "    %d, '%s', %d, '%s', "
                  . "    %d, '%s', %d, '%s', "
                  . "    %d, '%s', '%s', "
                  . "    %d, '%s', '%s', "
                  . "    %d, '%s', '%s', "
                  . "    %d, '%s', '%s', now() )",
                    $SESSION["user"], $query,
                    $email_b, $email_val, $status_b, $status_val_list, $severity_b, $severity_val_list,
                    $created_min_b, $created_min_val, $created_max_b, $created_max_val,
                    $modified_min_b, $modified_min_val, $modified_max_b, $modified_max_val,
                    $ip_addr_b, $ip_addr_qual, $ip_addr_val,
                    $ref_id_b, $ref_id_qual, $ref_id_val,
                    $category_b, $category_qual, $category_val,
                    $summary_b, $summary_qual, $summary_val );

    $selectSet = &$conn->Execute( $sql );

    if ( $selectSet === false )
    {
      $msg .= sprintf( "Error inserting: %s<BR>\n", $conn->ErrorMsg() );
    }

    $msg .= "Query Saved";
  }
  elseif ( $action == "Load" )
  {
    /*=-----------------------------------------------------------------=*/
    /*=-  Load the specified query into the current form.              -=*/
    /*=-----------------------------------------------------------------=*/

    $sql = sprintf( "select email_b, email_val, status_b, status_val, severity_b, severity_val, "
                  . "       created_min_b, created_min_val, created_max_b, created_max_val, "
                  . "       modified_min_b, modified_min_val, modified_max_b, modified_max_val, "
                  . "       ip_addr_b, ip_addr_qual, ip_addr_val, "
                  . "       ref_id_b, ref_id_qual, ref_id_val, "
                  . "       category_b, category_qual, category_val, "
                  . "       summary_b, summary_qual, summary_val "
                  . "  from lens_query "
                  . " where query = '%s' "
                  . "   and user = '%s'", $query_pulldown, $SESSION["user"] );

    $selectSet = &$conn->Execute( $sql );

    if ( $selectSet->EOF )
    {
      $sql = sprintf( "select email_b, email_val, status_b, status_val, severity_b, severity_val, "
                    . "       created_min_b, created_min_val, created_max_b, created_max_val, "
                    . "       modified_min_b, modified_min_val, modified_max_b, modified_max_val, "
                    . "       ip_addr_b, ip_addr_qual, ip_addr_val, "
                    . "       ref_id_b, ref_id_qual, ref_id_val, "
                    . "       category_b, category_qual, category_val, "
                    . "       summary_b, summary_qual, summary_val "
                    . "  from lens_query "
                    . " where query = '%s' "
                    . "   and user = 'SYSTEM'", $query_pulldown );

      $selectSet = &$conn->Execute( $sql );
    }

    if ( ! $selectSet->EOF )
    {
      $query = $query_pulldown;
      $email_b = $selectSet->fields["email_b"];
      $email_val = $selectSet->fields["email_val"];

      $status_b = $selectSet->fields["status_b"];
      unset( $status_val );
      foreach ( explode( ",", $selectSet->fields["status_val"] ) as $value )
        $status_val[] = $value;

      $severity_b = $selectSet->fields["severity_b"];
      unset( $severity_val );
      foreach ( explode( ",", $selectSet->fields["severity_val"] ) as $value )
        $severity_val[] = $value;

      $created_min_b = $selectSet->fields["created_min_b"];
      $created_min_val = $selectSet->fields["created_min_val"];
      $created_max_b = $selectSet->fields["created_max_b"];
      $created_max_val = $selectSet->fields["created_max_val"];
      $modified_min_b = $selectSet->fields["modified_min_b"];
      $modified_min_val = $selectSet->fields["modified_min_val"];
      $modified_max_b = $selectSet->fields["modified_max_b"];
      $modified_max_val = $selectSet->fields["modified_max_val"];
      $ip_addr_b = $selectSet->fields["ip_addr_b"];
      $ip_addr_qual = $selectSet->fields["ip_addr_qual"];
      $ip_addr_val = $selectSet->fields["ip_addr_val"];
      $ref_id_b = $selectSet->fields["ref_id_b"];
      $ref_id_qual = $selectSet->fields["ref_id_qual"];
      $ref_id_val = $selectSet->fields["ref_id_val"];
      $category_b = $selectSet->fields["category_b"];
      $category_qual = $selectSet->fields["category_qual"];
      $category_val = $selectSet->fields["category_val"];
      $summary_b = $selectSet->fields["summary_b"];
      $summary_qual = $selectSet->fields["summary_qual"];
      $summary_val = $selectSet->fields["summary_val"];
      $msg = "Query Loaded";
    }
    else
    {
      $msg = "Query Failed";
    }
  }
  elseif ( $action == "Delete" )
  {
    /*=-----------------------------------------------------------------=*/
    /*=-  Try to remove the query, if it exists.                       -=*/
    /*=-----------------------------------------------------------------=*/

    $sql = sprintf( "delete "
                  . "  from lens_query "
                  . " where query = '%s' "
                  . "   and user = '%s'", $query_pulldown, $SESSION["user"] );

    $selectSet = &$conn->Execute( $sql );

    if ( $selectSet === false )
    {
      printf( "Error deleting: %s<BR>\n", $conn->ErrorMsg() );
    }

    $msg = "Query Deleted";
  }
  elseif ( $action == "Reset" )
  {
    /*=-----------------------------------------------------------------=*/
    /*=-  Reset form parameters.                                       -=*/
    /*=-----------------------------------------------------------------=*/

    $query            = "";
    $email_b          = 0;
    $email_val        = "";
    $status_b         = 0;
    unset( $status_val );
    $status_val[]     = "";
    $severity_b       = 0;
    unset( $severity_val );
    $severity_val[]   = "";
    $created_min_b    = 0;
    $created_min_val  = "";
    $created_max_b    = 0;
    $created_max_val  = "";
    $modified_min_b   = 0;
    $modified_min_val = "";
    $modified_max_b   = 0;
    $modified_max_val = "";
    $ip_addr_b        = 0;
    $ip_addr_qual     = "";
    $ip_addr_val      = "";
    $ref_id_b         = 0;
    $ref_id_qual      = "";
    $ref_id_val       = "";
    $category_b       = 0;
    $category_qual    = "";
    $category_val     = "";
    $summary_b        = 0;
    $summary_qual     = "";
    $summary_val      = "";

    $msg = "Form Set to Default Values";
  }
  else
  {
    $msg = "Catastrophic ERROR!";
  }
}
else
{
    $query            = "";
    $email_b          = 0;
    $email_val        = "";
    $status_b         = 0;
    unset( $status_val );
    $status_val[]     = "";
    $severity_b       = 0;
    unset( $severity_val );
    $severity_val[]   = "";
    $created_min_b    = 0;
    $created_min_val  = "";
    $created_max_b    = 0;
    $created_max_val  = "";
    $modified_min_b   = 0;
    $modified_min_val = "";
    $modified_max_b   = 0;
    $modified_max_val = "";
    $ip_addr_b        = 0;
    $ip_addr_qual     = "";
    $ip_addr_val      = "";
    $ref_id_b         = 0;
    $ref_id_qual      = "";
    $ref_id_val       = "";
    $category_b       = 0;
    $category_qual    = "";
    $category_val     = "";
    $summary_b        = 0;
    $summary_qual     = "";
    $summary_val      = "";
}

/*************************************************************************/
/*                                                                       */
/*  Draw the HTML form                                                   */
/*                                                                       */
/*************************************************************************/

?>

<FORM>

<TABLE WIDTH="100%" BORDER=0 CELLPADDING=10 CELLSPACING=0><TR>
<TD CLASS=nav WIDTH="30%" ALIGN=LEFT>Query Management</TD>
<TD CLASS=nav-red WIDTH="40%" ALIGN=CENTER>
<? if ( isset( $msg ) ) { echo $msg; } else { echo '&nbsp;'; } ?></TD>
<TD CLASS=nav WIDTH="30%" ALIGN=RIGHT>&nbsp;</TD>
</TR></TABLE>

<BR>

<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=3>

<TR>
<TD CLASS=detail-key COLSPAN=2 ROWSPAN=3><CENTER>Query Name:</CENTER></TD>
<TD CLASS=detail-value><INPUT TYPE=TEXT SIZE=64 NAME=query VALUE="<? echo $query; ?>">
<INPUT TYPE=SUBMIT NAME=action VALUE="Save/Update Query"></TD>
</TR>

<TR>
<TD CLASS=detail-value>
<SELECT NAME=query_pulldown>
<?
$sql = sprintf( "select query from lens_query where user in ( 'SYSTEM', '%s' ) order by user, query", $SESSION["user"] );
$selectSet = &$conn->Execute( $sql );
while ( ! $selectSet->EOF )
{
  if ( $selectSet->fields["query"] == $SESSION["last_query"] )
    printf( "<OPTION SELECTED>%s", $selectSet->fields["query"] );
  else
    printf( "<OPTION>%s", $selectSet->fields["query"] );
  $selectSet->MoveNext();
}
?>
</SELECT>
<INPUT TYPE=SUBMIT NAME=action VALUE="Execute">
<INPUT TYPE=SUBMIT NAME=action VALUE="Load">
<INPUT TYPE=SUBMIT NAME=action VALUE="Delete">
<INPUT TYPE=SUBMIT NAME=action VALUE="Reset">
</TD>
</TR>

<TR>
<TD CLASS=detail-value>
<SELECT NAME=email_b>
<OPTION VALUE=0 <? if ( $email_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable E-Mail Notification
<OPTION VALUE=1 <? if ( $email_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Send Matching E-Mail Notifications To:
</SELECT>
<INPUT TYPE=TEXT SIZE=40 NAME=email_val VALUE="<? echo $email_val; ?>">
</TD>
</TR>

<TR><TD COLSPAN=3>&nbsp;</TD></TR>

<TR><TD CLASS=detail-key>Status:</TD>
<TD CLASS=detail-value>
<SELECT NAME=status_b>
<OPTION VALUE=0 <? if ( $status_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $status_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value>
<?
for ( $i = 0; $i < 5; $i++ )
{
  $status_val_arr[$i] = 0;
}
if ( isset( $status_val ) )
{
  for ( $i = 0; $i < count( $status_val ); $i++ )
  {
    $status_val_arr[$status_val[$i]] = 1;
  }
}
$selectSet = &$conn->Execute( 'select status, long_desc from lens_status order by status' );
while ( ! $selectSet->EOF )
{
  printf( "<INPUT TYPE=\"CHECKBOX\" NAME=status_val[] " );
  if ( $status_val_arr[$selectSet->fields["status"]] == 1 )
  {
    printf( " CHECKED " );
  }
  printf( "VALUE=\"%d\">%s&nbsp;", $selectSet->fields["status"], $selectSet->fields["long_desc"] );
  $selectSet->MoveNext();
}
?>
</TD></TR>

<TR><TD CLASS=detail-key>Severity:</TD>
<TD CLASS=detail-value>
<SELECT NAME=severity_b>
<OPTION VALUE=0 <? if ( $severity_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $severity_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value>
<?
for ( $i = 0; $i < 8; $i++ )
{
  $severity_val_arr[$i] = 0;
}
if ( isset( $severity_val ) )
{
  for ( $i = 0; $i < count( $severity_val ); $i++ )
  {
    $severity_val_arr[$severity_val[$i]] = 1;
  }
}
$selectSet = &$conn->Execute( 'select severity, long_desc, color from lens_severity order by severity' );
while ( ! $selectSet->EOF )
{
  printf( "<INPUT TYPE=\"CHECKBOX\" NAME=severity_val[] " );
  if ( $severity_val_arr[$selectSet->fields["severity"]] == 1 )
  {
    printf( " CHECKED " );
  }
  printf( "VALUE=\"%d\">%s&nbsp;", $selectSet->fields["severity"], $selectSet->fields["long_desc"] );
  $selectSet->MoveNext();
}
?>
</TD></TR>

<TR><TD CLASS=detail-key ROWSPAN=2>Created:</TD>
<TD CLASS=detail-value><SELECT NAME=created_min_b>
<OPTION VALUE=0 <? if ( $created_min_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $created_min_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value ALIGN=RIGHT><B>Minimum:</B>&nbsp;
<INPUT TYPE=text SIZE=19 NAME=created_min_val VALUE="<? echo $created_min_val; ?>">
&nbsp;&nbsp;&nbsp;Example:  1999-01-01 00:00:00</TD></TR>

<TR>
<TD CLASS=detail-value><SELECT NAME=created_max_b>
<OPTION VALUE=0 <? if ( $created_max_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $created_max_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value ALIGN=RIGHT><B>Maximum:</B>&nbsp;
<INPUT TYPE=text SIZE=19 NAME=created_max_val VALUE="<? echo $created_max_val; ?>">
&nbsp;&nbsp;&nbsp;Example:  2003-12-31 23:59:59</TD></TR>

<TR><TD CLASS=detail-key ROWSPAN=2>Modified:</TD>
<TD CLASS=detail-value><SELECT NAME=modified_min_b>
<OPTION VALUE=0 <? if ( $modified_min_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $modified_min_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value ALIGN=RIGHT><B>Minimum:</B>&nbsp;
<INPUT TYPE=text SIZE=19 NAME=modified_min_val VALUE="<? echo $modified_min_val; ?>">
&nbsp;&nbsp;&nbsp;Example:  1999-01-01 00:00:00</TD></TR>

<TR>
<TD CLASS=detail-value><SELECT NAME=modified_max_b>
<OPTION VALUE=0 <? if ( $modified_max_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $modified_max_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value ALIGN=RIGHT><B>Maximum:</B>&nbsp;
<INPUT TYPE=text SIZE=19 NAME=modified_max_val VALUE="<? echo $modified_max_val; ?>">
&nbsp;&nbsp;&nbsp;Example:  2003-12-31 23:59:59</TD></TR>

<TR><TD CLASS=detail-key>IP Address:</TD>
<TD CLASS=detail-value><SELECT NAME=ip_addr_b>
<OPTION VALUE=0 <? if ( $ip_addr_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $ip_addr_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value><SELECT NAME=ip_addr_qual>
<OPTION VALUE="=" <? if ( $ip_addr_qual == "=" ) echo ' SELECTED>'; else echo '>'; ?>=
<OPTION VALUE="LIKE" <? if ( $ip_addr_qual == "LIKE" ) echo ' SELECTED>'; else echo '>'; ?>LIKE
<OPTION VALUE="IN" <? if ( $ip_addr_qual == "IN" ) echo ' SELECTED>'; else echo '>'; ?>IN
<OPTION VALUE="NOT LIKE" <? if ( $ip_addr_qual == "NOT LIKE" ) echo ' SELECTED>'; else echo '>'; ?>NOT LIKE
<OPTION VALUE="NOT IN" <? if ( $ip_addr_qual == "NOT IN" ) echo ' SELECTED>'; else echo '>'; ?>NOT IN
</SELECT>
<INPUT TYPE=text SIZE=20 NAME=ip_addr_val VALUE="<? echo $ip_addr_val; ?>">
&nbsp;&nbsp;&nbsp;Example:  LIKE 205.214.10.%</TD></TR>

<TR><TD CLASS=detail-key>Ref ID:</TD>
<TD CLASS=detail-value><SELECT NAME=ref_id_b>
<OPTION VALUE=0 <? if ( $ref_id_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $ref_id_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value><SELECT NAME=ref_id_qual>
<OPTION VALUE="=" <? if ( $ref_id_qual == "=" ) echo ' SELECTED>'; else echo '>'; ?>=
<OPTION VALUE="IN" <? if ( $ref_id_qual == "IN" ) echo ' SELECTED>'; else echo '>'; ?>IN
<OPTION VALUE="NOT IN" <? if ( $ref_id_qual == "NOT IN" ) echo ' SELECTED>'; else echo '>'; ?>NOT IN
</SELECT>
<INPUT TYPE=text SIZE=20 NAME=ref_id_val VALUE="<? echo $ref_id_val; ?>"></TD></TR>

<TR><TD CLASS=detail-key>Category:</TD>
<TD CLASS=detail-value><SELECT NAME=category_b>
<OPTION VALUE=0 <? if ( $category_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $category_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value><SELECT NAME=category_qual>
<OPTION VALUE="=" <? if ( $category_qual == "=" ) echo ' SELECTED>'; else echo '>'; ?>=
<OPTION VALUE="LIKE" <? if ( $category_qual == "LIKE" ) echo ' SELECTED>'; else echo '>'; ?>LIKE
<OPTION VALUE="IN" <? if ( $category_qual == "IN" ) echo ' SELECTED>'; else echo '>'; ?>IN
<OPTION VALUE="NOT LIKE" <? if ( $category_qual == "NOT LIKE" ) echo ' SELECTED>'; else echo '>'; ?>NOT LIKE
<OPTION VALUE="NOT IN" <? if ( $category_qual == "NOT IN" ) echo ' SELECTED>'; else echo '>'; ?>NOT IN
</SELECT>
<INPUT TYPE=text SIZE=60 NAME=category_val VALUE="<? echo $category_val; ?>"></TD></TR>

<TR><TD CLASS=detail-key>Summary:</TD>
<TD CLASS=detail-value><SELECT NAME=summary_b>
<OPTION VALUE=0 <? if ( $summary_b == 0 ) echo ' SELECTED>'; else echo '>'; ?>Disable
<OPTION VALUE=1 <? if ( $summary_b == 1 ) echo ' SELECTED>'; else echo '>'; ?>Enable
</SELECT></TD>
<TD CLASS=detail-value><SELECT NAME=summary_qual>
<OPTION VALUE="=" <? if ( $summary_qual == "=" ) echo ' SELECTED>'; else echo '>'; ?>=
<OPTION VALUE="LIKE" <? if ( $summary_qual == "LIKE" ) echo ' SELECTED>'; else echo '>'; ?>LIKE
<OPTION VALUE="IN" <? if ( $summary_qual == "IN" ) echo ' SELECTED>'; else echo '>'; ?>IN
<OPTION VALUE="NOT LIKE" <? if ( $summary_qual == "NOT LIKE" ) echo ' SELECTED>'; else echo '>'; ?>NOT LIKE
<OPTION VALUE="NOT IN" <? if ( $summary_qual == "NOT IN" ) echo ' SELECTED>'; else echo '>'; ?>NOT IN
</SELECT>
<INPUT TYPE=text SIZE=60 NAME=summary_val VALUE="<? echo $summary_val ?>"></TD></TR>

</TABLE>

</FORM>

<?
$selectSet->Close();
$conn->Close();
?>

</CENTER>

<?
include('footer.php');
?>

</BODY>
</HTML>

<?

}

/*************************************************************************/
/*                                                                       */
/*************************************************************************/

?>
