<?

/*************************************************************************/
/*                                                                       */
/*  NetworkLens                                                          */
/*  Copyright (C) 2002, I-Link Incorporated                              */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License as       */
/*  published by the Free Software Foundation; either version 2 of the   */
/*  License, or (at your option) any later version.                      */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*  GNU General Public License for more details.                         */
/*                                                                       */
/*  You should have received a copy of the GNU General Public License    */
/*  along with this program; if not, write to the Free Software          */
/*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            */
/*                                                                       */
/*  Show raw SNMP trap information for a given TRAP_ID                   */
/*                                                                       */
/*  Change Log:                                                          */
/*                                                                       */
/*  2002/02/20  GEB  Initial script                                      */
/*                                                                       */
/*************************************************************************/

require_once( "common.php" );

include('adodb/adodb.inc.php');
$conn = &ADONewConnection( $dbtype );
$conn->PConnect( $dbhost, $dbuser, $dbpass, $dbname );

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

/*************************************************************************/
/*                                                                       */
/*  If the user is not logged in, send them to the login screen to be    */
/*  authenticated; else, show the detail screen.                         */
/*                                                                       */
/*************************************************************************/

if ( ! is_logged_in() )
{
  $SESSION["return_url"] = $REQUEST_URI;
  header( "Location: login.php" );
}
else
{

?>

<HTML>

<HEAD>
<TITLE>NetworkLens SNMP Trap Detail</TITLE>
<LINK REL=StyleSheet HREF="style.css" TYPE="text/css">
</HEAD>

<BODY>

<?
include('header.php');
?>

<?
if ( ! isset( $trap_id ) )
{
  include('footer.php');
  printf( "</BODY></HTML>\n" );
  return;
}
?>

<CENTER>

<?
$sql = "select trap_id, "
     . "       created, "
     . "       host_name, "
     . "       host_addr, "
     . "       id "
     . "  from lens_trap "
     . " where trap_id = $trap_id";

$recordSet = &$conn->Execute( $sql );

if ( $recordSet->EOF )
{
  include('footer.php');
  printf( "</BODY></HTML>\n" );
  return;
}

printf( "<TABLE WIDTH=\"100%%\" BORDER=0 CELLPADDING=10 CELLSPACING=0>\n" );
printf( "<TR>\n" );
printf( "<TD CLASS=nav WIDTH=\"30%%\" ALIGN=LEFT>SNMP Trap %d</TD>\n", $trap_id );
printf( "<TD CLASS=nav-red WIDTH=\"40%%\" ALIGN=CENTER>&nbsp;</TD>\n" );
printf( "<TD CLASS=nav WIDTH=\"30%%\" ALIGN=RIGHT>%s</TD>\n", $recordSet->fields["host_name"] );
printf( "</TR>\n" );
printf( "</TABLE>\n" );
printf( "<BR>\n" );

printf( "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=3>\n" );

printf( "<TR><TD CLASS=detail-key>Trap ID:</TD>   <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["trap_id"] );
printf( "<TR><TD CLASS=detail-key>Created:</TD>   <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["created"] );
printf( "<TR><TD CLASS=detail-key>Host Name:</TD> <TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["host_name"] );
printf( "<TR><TD CLASS=detail-key>IP Address:</TD><TD CLASS=detail-value>%s</TD></TR>\n", $recordSet->fields["host_addr"] );
printf( "<TR><TD CLASS=detail-key>Event ID:</TD>  <TD CLASS=detail-value>" );
printf( "<A HREF=\"detail.php?id=%d\">%d</A></TD></TR>\n", $recordSet->fields["id"], $recordSet->fields["id"] );

/*************************************************************************/
/*                                                                       */
/*  Show the raw OID values that were part of the original trap.         */
/*                                                                       */
/*************************************************************************/

$recordSet = &$conn->Execute( "select oid_id, oid_value "
                            . "  from lens_trap_args "
                            . " where trap_id = $trap_id "
                            . " order by oid_id" );

if ( ! $recordSet->EOF )
{
  printf( "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n" );

  while ( ! $recordSet->EOF ) {
    printf( "<TR>\n" );
    printf( "<TD CLASS=trapdetail-key>%s</TD>", $recordSet->fields["oid_id"] );
    printf( "<TD CLASS=trapdetail-value>%s</TD>", $recordSet->fields["oid_value"] );
    printf( "</TR>\n" );
    $recordSet->MoveNext();
  }
}

printf( "</TABLE>\n" );

$selectSet->Close();
$recordSet->Close();
$conn->Close();
?>

</CENTER>

<?
include('footer.php');
?>

</BODY>
</HTML>

<?

}

/*************************************************************************/
/*                                                                       */
/*************************************************************************/

?>
