# MySQL dump 8.16
#
# Host: localhost    Database: lens
#--------------------------------------------------------
# Server version	3.23.47

#
# Table structure for table 'lens_event'
#

CREATE TABLE lens_event (
  id int(11) NOT NULL auto_increment,
  status int(11) NOT NULL default '0',
  severity int(11) NOT NULL default '0',
  created datetime NOT NULL default '0000-00-00 00:00:00',
  modified datetime default NULL,
  ip_addr varchar(15) default NULL,
  ref_id int(11) default NULL,
  category text,
  summary text,
  PRIMARY KEY  (id),
  UNIQUE KEY lens_event_0 (status,severity,id)
) TYPE=MyISAM;

#
# Dumping data for table 'lens_event'
#

#
# Table structure for table 'lens_log'
#

CREATE TABLE lens_log (
  id int(11) NOT NULL default '0',
  modified datetime NOT NULL default '0000-00-00 00:00:00',
  user varchar(32) NOT NULL default '',
  trap_id int(11) default NULL,
  log text NOT NULL,
  KEY lens_log_0 (id)
) TYPE=MyISAM;

#
# Dumping data for table 'lens_log'
#

#
# Table structure for table 'lens_query'
#

CREATE TABLE lens_query (
  user varchar(32) NOT NULL default '',
  query varchar(64) NOT NULL default '',
  email_b int(11) NOT NULL default '0',
  email_val text,
  status_b int(11) NOT NULL default '0',
  status_val text,
  severity_b int(11) NOT NULL default '0',
  severity_val text,
  created_min_b int(11) NOT NULL default '0',
  created_min_val datetime default NULL,
  created_max_b int(11) NOT NULL default '0',
  created_max_val datetime default NULL,
  modified_min_b int(11) NOT NULL default '0',
  modified_min_val datetime default NULL,
  modified_max_b int(11) NOT NULL default '0',
  modified_max_val datetime default NULL,
  ip_addr_b int(11) NOT NULL default '0',
  ip_addr_qual text,
  ip_addr_val text,
  ref_id_b int(11) NOT NULL default '0',
  ref_id_qual text,
  ref_id_val int(11) default NULL,
  category_b int(11) NOT NULL default '0',
  category_qual text,
  category_val text,
  summary_b int(11) NOT NULL default '0',
  summary_qual text,
  summary_val text,
  last_notify datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (user,query)
) TYPE=MyISAM;

#
# Dumping data for table 'lens_query'
#

INSERT INTO lens_query VALUES ('SYSTEM','ALL EVENTS',0,'',0,'',0,'',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'=','',0,'=',0,0,'=','',0,'=','','0000-00-00 00:00:00');
INSERT INTO lens_query VALUES ('SYSTEM','DEFAULT',0,NULL,1,'0,1,2,3',0,NULL,0,NULL,0,NULL,0,NULL,0,NULL,0,NULL,NULL,0,NULL,NULL,0,NULL,NULL,0,NULL,NULL,'0000-00-00 00:00:00');
INSERT INTO lens_query VALUES ('SYSTEM','Active Events',0,NULL,1,'0,1,2,3',0,NULL,0,NULL,0,NULL,0,NULL,0,NULL,0,NULL,NULL,0,NULL,NULL,0,NULL,NULL,0,NULL,NULL,'0000-00-00 00:00:00');
INSERT INTO lens_query VALUES ('SYSTEM','All but SYSLOG',0,'',0,'',0,'',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'=','',0,'=',0,1,'NOT LIKE','%SYSLOG%',0,'=','','0000-00-00 00:00:00');

#
# Table structure for table 'lens_severity'
#

CREATE TABLE lens_severity (
  severity int(11) NOT NULL default '0',
  short_desc text NOT NULL,
  long_desc text NOT NULL,
  color varchar(7) NOT NULL default ''
) TYPE=MyISAM;

#
# Dumping data for table 'lens_severity'
#

INSERT INTO lens_severity VALUES (0,'Unk','Unknown','#C0C0C0');
INSERT INTO lens_severity VALUES (1,'Alert','Alert','#FF0000');
INSERT INTO lens_severity VALUES (2,'Crit','Critical','#FF8080');
INSERT INTO lens_severity VALUES (3,'Err','Error','#FFC0C0');
INSERT INTO lens_severity VALUES (4,'Warn','Warning','#FFC080');
INSERT INTO lens_severity VALUES (5,'Notif','Notification','#FFFF80');
INSERT INTO lens_severity VALUES (6,'Inf','Informational','#A0FFC0');
INSERT INTO lens_severity VALUES (7,'Debug','Debugging','#A0C0FF');

#
# Table structure for table 'lens_status'
#

CREATE TABLE lens_status (
  status int(11) NOT NULL default '0',
  short_desc text NOT NULL,
  long_desc text NOT NULL
) TYPE=MyISAM;

#
# Dumping data for table 'lens_status'
#

INSERT INTO lens_status VALUES (0,'New','New');
INSERT INTO lens_status VALUES (1,'Ack','Acknowledged');
INSERT INTO lens_status VALUES (2,'Wrk','Working');
INSERT INTO lens_status VALUES (3,'Res','Resolved');
INSERT INTO lens_status VALUES (4,'Cls','Closed');

#
# Table structure for table 'lens_status_change'
#

CREATE TABLE lens_status_change (
  old_status int(11) NOT NULL default '0',
  new_status int(11) NOT NULL default '0',
  log_required int(11) NOT NULL default '0'
) TYPE=MyISAM;

#
# Dumping data for table 'lens_status_change'
#

INSERT INTO lens_status_change VALUES (0,1,0);
INSERT INTO lens_status_change VALUES (0,2,0);
INSERT INTO lens_status_change VALUES (0,3,1);
INSERT INTO lens_status_change VALUES (0,4,1);
INSERT INTO lens_status_change VALUES (1,2,0);
INSERT INTO lens_status_change VALUES (1,3,1);
INSERT INTO lens_status_change VALUES (1,4,1);
INSERT INTO lens_status_change VALUES (2,3,1);
INSERT INTO lens_status_change VALUES (2,4,1);
INSERT INTO lens_status_change VALUES (3,4,1);
INSERT INTO lens_status_change VALUES (3,2,1);
INSERT INTO lens_status_change VALUES (4,2,1);

#
# Table structure for table 'lens_trap'
#

CREATE TABLE lens_trap (
  trap_id int(11) NOT NULL auto_increment,
  created datetime NOT NULL default '0000-00-00 00:00:00',
  host_name text NOT NULL,
  host_addr varchar(15) NOT NULL default '',
  id int(11) default NULL,
  PRIMARY KEY  (trap_id),
  KEY lens_trap_0 (id)
) TYPE=MyISAM;

#
# Dumping data for table 'lens_trap'
#

#
# Table structure for table 'lens_trap_args'
#

CREATE TABLE lens_trap_args (
  trap_id int(11) NOT NULL default '0',
  oid_id text NOT NULL,
  oid_value text NOT NULL,
  KEY lens_trap_args_0 (trap_id)
) TYPE=MyISAM;

#
# Dumping data for table 'lens_trap_args'
#

#
# Table structure for table 'lens_trap_category'
#

CREATE TABLE lens_trap_category (
  trap_oid text NOT NULL,
  category text NOT NULL
) TYPE=MyISAM;

#
# Dumping data for table 'lens_trap_category'
#

INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.3052.0.101','Premises Security');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15414','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15415','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.5450.0.1','CE Error');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.6.3.1.1.5.1','SNMPv2 coldStart');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.6.3.1.1.5.2','SNMPv2 warmStart');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.5450.0.2','CE Warning');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.5450.0.3','CE Information');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.5450.0.4','CE Device Start');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.5450.0.5','CE Device Terminate');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.6.3.1.1.5.5','SNMPv2 authenticationFailure');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9002.0.1','LXPRO.COM Test Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9.0.1','CISCO Generic Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9.9.43.2.0.1','CISCO Cfg Mgmt');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.181.2.2.0.5001','ADC Kentrox');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.181.2.2.0.5002','ADC Kentrox');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15400','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15401','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15402','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15403','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15404','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15405','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15406','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15407','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15408','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15409','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15410','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15411','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15412','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15413','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15416','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15417','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15418','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15419','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15420','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15421','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15422','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15423','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15424','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15425','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15426','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15427','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15428','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15429','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15430','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15431','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15432','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15433','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15434','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15435','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15436','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15437','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15438','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15439','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15701','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.664.2.154.0.15702','ATLAS Configuration');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9002.0.11.1','MON Alert');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9002.0.11.2','MON UpAlert');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.1','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.2','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.3','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.4','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.5','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.6','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.7','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.8','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.9','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.10','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.11','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.12','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.13','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.14','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.15','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.16','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.17','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.18','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.19','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.20','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.21','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.22','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.23','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.24','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.25','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.26','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.27','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.28','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.29','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.30','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.31','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.32','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.33','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.34','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.35','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.36','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.37','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.38','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.39','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.40','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.41','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.42','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.43','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.44','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.45','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.46','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.47','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.48','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.49','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.50','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.51','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.52','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.53','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.54','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.55','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.56','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.57','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.58','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.59','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.60','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.61','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.62','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.63','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.64','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.65','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.66','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.67','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.68','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.69','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.70','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.71','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.72','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.73','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.74','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.75','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.76','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.77','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.78','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.79','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.80','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.81','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.82','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.83','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.84','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.85','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.86','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.87','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.88','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.89','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.90','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.91','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.92','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.93','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.94','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.95','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.96','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.97','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.98','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.99','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.100','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.101','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.102','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.103','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.104','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.105','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.106','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.107','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.108','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.109','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.110','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.111','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.112','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.113','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.114','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.115','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.116','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.117','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.118','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.119','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.120','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.121','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.4030.1.2.0.122','UPS');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9002.0.11','MON Alert - deprecated');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.1','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.2','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.3','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.4','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.5','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.6','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.7','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.8','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.9','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.10','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.11','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.12','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.13','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.14','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.15','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.16','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.17','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.18','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.19','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.20','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.21','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.22','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.23','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.24','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.25','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.26','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.27','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.28','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.29','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.30','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.31','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.32','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.33','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.34','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.35','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.36','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.37','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.38','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.39','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.40','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.41','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.42','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.43','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.44','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.45','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.46','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.47','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.48','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.49','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.50','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.51','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.52','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.53','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.54','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.55','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.56','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.57','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.58','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.59','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.60','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.61','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.62','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.63','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.64','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.65','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.66','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.67','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.68','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.69','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.70','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.71','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.72','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.73','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.74','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.75','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.76','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.77','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.78','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.79','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.80','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.81','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.82','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.83','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.84','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.85','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.86','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.87','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.88','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.89','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.90','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.91','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.92','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.93','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.94','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.95','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.96','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.97','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.98','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.99','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.100','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.101','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.102','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.103','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.104','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.105','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.106','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.107','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.108','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.109','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.110','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.111','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.112','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.113','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.114','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.115','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.116','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.117','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.118','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.119','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.318.0.120','APC Trap');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1','CISCO HSRP');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.6.3.1.1.5.3','Interface Link');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.6.3.1.1.5.4','Interface Link');
INSERT INTO lens_trap_category VALUES ('.1.3.6.1.4.1.9.0.0','CISCO Generic Trap');

#
# Table structure for table 'lens_trap_severity'
#

CREATE TABLE lens_trap_severity (
  trap_oid text NOT NULL,
  severity int(11) NOT NULL default '0'
) TYPE=MyISAM;

#
# Dumping data for table 'lens_trap_severity'
#

INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.5450.0.1',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.6.3.1.1.5.3',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.6.3.1.1.5.4',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.6.3.1.1.5.5',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.5450.0.3',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.5450.0.4',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.5450.0.5',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.6.3.1.1.5.1',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.6.3.1.1.5.2',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.3052.0.101',5);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.5450.0.2',5);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9002.0.1',7);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9.0.1',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9.9.43.2.0.1',5);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.181.2.2.0.5001',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.181.2.2.0.5002',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',3);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',3);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',3);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',3);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',6);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',6);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',6);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15701',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.664.2.154.0.15702',2);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9002.0.11.1',1);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9002.0.11.2',3);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.1',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.2',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.3',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.4',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.5',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.6',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.7',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.8',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.9',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.10',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.11',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.12',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.13',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.14',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.15',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.16',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.17',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.18',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.19',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.20',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.21',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.22',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.23',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.24',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.25',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.26',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.27',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.28',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.29',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.30',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.31',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.32',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.33',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.34',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.35',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.36',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.37',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.38',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.39',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.40',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.41',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.42',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.43',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.44',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.45',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.46',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.47',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.48',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.49',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.50',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.51',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.52',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.53',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.54',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.55',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.56',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.57',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.58',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.59',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.60',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.61',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.62',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.63',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.64',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.65',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.66',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.67',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.68',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.69',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.70',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.71',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.72',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.73',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.74',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.75',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.76',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.77',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.78',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.79',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.80',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.81',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.82',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.83',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.84',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.85',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.86',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.87',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.88',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.89',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.90',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.91',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.92',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.93',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.94',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.95',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.96',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.97',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.98',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.99',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.100',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.101',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.102',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.103',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.104',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.105',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.106',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.107',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.108',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.109',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.110',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.111',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.112',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.113',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.114',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.115',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.116',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.117',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.118',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.119',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.120',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.121',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.4030.1.2.0.122',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9002.0.11',7);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.1',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.2',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.3',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.4',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.5',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.6',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.7',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.8',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.9',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.10',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.11',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.12',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.13',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.14',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.15',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.16',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.17',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.18',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.19',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.20',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.21',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.22',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.23',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.24',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.25',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.26',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.27',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.28',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.29',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.30',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.31',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.32',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.33',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.34',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.35',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.36',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.37',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.38',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.39',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.40',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.41',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.42',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.43',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.44',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.45',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.46',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.47',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.48',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.49',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.50',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.51',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.52',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.53',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.54',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.55',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.56',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.57',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.58',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.59',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.60',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.61',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.62',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.63',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.64',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.65',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.66',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.67',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.68',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.69',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.70',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.71',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.72',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.73',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.74',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.75',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.76',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.77',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.78',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.79',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.80',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.81',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.82',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.83',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.84',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.85',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.86',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.87',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.88',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.89',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.90',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.91',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.92',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.93',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.94',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.95',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.96',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.97',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.98',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.99',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.100',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.101',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.102',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.103',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.104',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.105',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.106',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.107',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.108',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.109',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.110',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.111',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.112',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.113',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.114',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.115',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.116',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.117',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.118',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.119',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.318.0.120',4);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1',5);
INSERT INTO lens_trap_severity VALUES ('.1.3.6.1.4.1.9.0.0',4);

#
# Table structure for table 'lens_trap_summary_parts'
#

CREATE TABLE lens_trap_summary_parts (
  trap_oid text NOT NULL,
  sequence int(11) NOT NULL default '0',
  part_type char(1) NOT NULL default '',
  part text NOT NULL
) TYPE=MyISAM;

#
# Dumping data for table 'lens_trap_summary_parts'
#

INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.3052.0.101',1,'V','.1.3.6.1.4.1.3052.2.1.2.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',1,'T','ATLAS 15414: Current interval severely errored ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',2,'T','framing second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',3,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',4,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',5,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',6,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',7,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',8,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',9,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',10,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',11,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',12,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15414',13,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',1,'T','ATLAS 15415: Current interval unavailable ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',2,'T','second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',3,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',4,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',5,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',6,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',7,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',8,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',9,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',10,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',11,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',12,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15415',13,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',1,'V','.1.3.6.1.4.1.5450.1.2.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',2,'T',' (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',3,'V','.1.3.6.1.4.1.5450.1.2.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',4,'T',':');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',5,'V','.1.3.6.1.4.1.5450.1.2.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',6,'T',':');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',7,'V','.1.3.6.1.4.1.5450.1.2.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.1',8,'T',')');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',1,'V','.1.3.6.1.4.1.5450.1.4.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',2,'T',' (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',3,'V','.1.3.6.1.4.1.5450.1.4.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',4,'T',':');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',5,'V','.1.3.6.1.4.1.5450.1.4.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',6,'T',':');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',7,'V','.1.3.6.1.4.1.5450.1.4.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.4',8,'T',')');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',1,'V','.1.3.6.1.4.1.5450.1.5.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',2,'T',' (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',3,'V','.1.3.6.1.4.1.5450.1.5.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',4,'T',':');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',5,'V','.1.3.6.1.4.1.5450.1.5.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',6,'T',':');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',7,'V','.1.3.6.1.4.1.5450.1.5.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.5450.0.5',8,'T',')');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.3',1,'T','Link DOWN: ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.3',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.3',3,'T',' (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.3',4,'S','.1.3.6.1.2.1.2.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.3',5,'T',') ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.3',6,'S','.1.3.6.1.2.1.2.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.4',1,'T','Link UP: ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.4',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.4',3,'T',' (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.4',4,'S','.1.3.6.1.2.1.2.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.4',5,'T',') ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.6.3.1.1.5.4',6,'S','.1.3.6.1.2.1.2.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.1',1,'T','LXPRO.COM Test Trap (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.1',2,'V','.1.3.6.1.4.1.9002.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.1',3,'T',')');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.0.1',1,'T','CISCO Generic Trap');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.43.2.0.1',1,'T','Notification of a configuration management event as ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.43.2.0.1',2,'T','recorded in ccmHistoryEventTable.');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.181.2.2.0.5001',1,'T','ADC Kentrox Generic Trap 5001');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.181.2.2.0.5002',1,'T','ADC Kentrox Generic Trap 5002');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',1,'T','ATLAS 15400: Received yellow alarm active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15400',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',1,'T','ATLAS 15401: Received yellow alarm inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15401',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',1,'T','ATLAS 15402: Received AIS active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15402',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',1,'T','ATLAS 15403: Received AIS inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15403',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',1,'T','ATLAS 15404: Red alarm is active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15404',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',1,'T','ATLAS 15405: Red alarm is inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15405',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',1,'T','ATLAS 15406: Loss of signal (LOS) is active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15406',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',1,'T','ATLAS 15407: Loss of signal (LOS) is inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15407',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',1,'T','ATLAS 15408: (AIS) being transmitted from Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15408',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',1,'T','ATLAS 15409: (AIS) no longer being transmitted from Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15409',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',1,'T','ATLAS 15410: A yellow alarm is being transmitted from Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15410',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',1,'T','ATLAS 15411: A yellow alarm is no longer being transmitted from Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15411',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',1,'T','ATLAS 15412: Current interval errored second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15412',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',1,'T','ATLAS 15413: Current interval severely errored second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15413',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',1,'T','ATLAS 15416: Current interval controlled slip second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15416',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',1,'T','ATLAS 15417: Current interval path code violations threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15417',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',1,'T','ATLAS 15418: Current interval line errored second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15418',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',1,'T','ATLAS 15419: Current interval line code violations threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15419',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',1,'T','ATLAS 15420: Total errored second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15420',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',1,'T','ATLAS 15421: Total severely errored second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15421',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',1,'T','ATLAS 15422: Total severely errored framing second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15422',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',1,'T','ATLAS 15423: Total unavailable second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15423',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',1,'T','ATLAS 15424: Total controlled slip second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15424',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',1,'T','ATLAS 15425: Total path code violations threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15425',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',1,'T','ATLAS 15426: Total line errored second threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15426',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',1,'T','ATLAS 15427: Total line code violations threshold exceeded for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',11,'T',', Line Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15427',12,'S','.1.3.6.1.2.1.10.18.6.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',1,'T','ATLAS800 15428: T3 Red alarm is active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15428',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',1,'T','ATLAS800 15429: T3 Red alarm is inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15429',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',1,'T','ATLAS800 15430: T3 Loss of signal (LOS) is active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15430',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',1,'T','ATLAS800 15431: T3 Loss of signal (LOS) is inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15431',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',1,'T','ATLAS 15432: Backup attempt for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15432',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',1,'T','ATLAS 15433: Backup failure for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15433',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',1,'T','ATLAS 15434: Backup active for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15434',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',1,'T','ATLAS 15435: Backup inactive for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15435',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',1,'T','ATLAS 15436: Test call originated for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15436',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',1,'T','ATLAS 15437: Test call connected for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15437',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',1,'T','ATLAS 15438: Test call passed for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15438',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',1,'T','ATLAS 15439: Test call failed for Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',3,'T',', Slot ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',4,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',5,'T',', Port ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',6,'S','.1.3.6.1.4.1.664.2.154.1.3.2.1.3');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',7,'T',', Module Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',8,'S','.1.3.6.1.4.1.664.2.154.1.1.3.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',9,'T',', Box Status ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15439',10,'S','.1.3.6.1.4.1.664.2.154.1.3.4');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15701',1,'T','ATLAS800 15701: Module Offline Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15701',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15702',1,'T','ATLAS800 15702: Module Online Line ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.664.2.154.0.15702',2,'S','.1.3.6.1.2.1.2.2.1.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.1',1,'T','MON Alert: (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.1',2,'V','.1.3.6.1.4.1.9002.11.5');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.1',3,'T',') service (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.1',4,'V','.1.3.6.1.4.1.9002.11.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.1',5,'T',')');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.2',1,'T','MON Up Alert: (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.2',2,'V','.1.3.6.1.4.1.9002.11.5');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.2',3,'T',') service (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.2',4,'V','.1.3.6.1.4.1.9002.11.1');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11.2',5,'T',')');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.1',1,'T','Sensor Abnormal (UF007)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.2',1,'T','Sensor Abnormal (UF105)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.3',1,'T','DC Overvoltage (UF102)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.4',1,'T','DC Undervoltage (UF103)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.5',1,'T','Sensor Abnormal (UF216)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.6',1,'T','Inverter Overvoltage (UF201)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.7',1,'T','Inverter Undervoltage (UF202)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.8',1,'T','UPS Control Circuit Error (UF306)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.9',1,'T','UPS Control Circuit Error (UF301)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.10',1,'T','UPS Control Circuit Error (UF305)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.11',1,'T','Inverter Overcurrent (UF203)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.12',1,'T','UPS Control Circuit Error (UF302)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.13',1,'T','UPS Control Circuit Error (UF303)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.14',1,'T','UPS Control Circuit Error (UF304)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.15',1,'T','Fan Abnormal (UF212)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.16',1,'T','CB2 Abnormal (UF107)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.17',1,'T','Cooling Fan Abnormal (UF214)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.18',1,'T','Inv. or Conv. Overtemperature (UF213)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.19',1,'T','52C Abnormal (UF209)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.20',1,'T','52C Abnormal (UF210)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.21',1,'T','Inv Voltage Abnormal (UF309)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.22',1,'T','52S Abnormal (UF401)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.23',1,'T','52S Abnormal (UF402)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.24',1,'T','CB1 Abnormal (UF053)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.25',1,'T','CB1 Tripped (UF052)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.26',1,'T','52C Abnormal (UF257)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.27',1,'T','52S Abnormal (UF451)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.28',1,'T','CB2 Tripped (UF153)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.29',1,'T','Battery Liquid level Low (UF158)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.30',1,'T','Battery Overtemperature (UF157)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.31',1,'T','CB2 Open (Battery Overtemp) (UF156)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.32',1,'T','Output Voltage Abnormal (UF256)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.33',1,'T','Control Pwr Supply Abnormal (UF352)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.34',1,'T','DC Ground Falut (UF159)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.35',1,'T','Sensor Abnormal (UF160)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.36',1,'T','Blown Control Fuse  (UF351)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.37',1,'T','DC Voltage Abnormal (UF151)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.38',1,'T','DC Voltage Abnormal (UF152)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.39',1,'T','UPS Ctrl Circuit Error (UF356)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.40',1,'T','\"Inverter Start\" Button Abnormal (UF357)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.41',1,'T','\"Inverter Stop\" Button Abnormal (UF358)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.42',1,'T','\"Inverter Supply\" Button Abnormal (UF359)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.43',1,'T','\"Bypass Supply\" Switch Abnormal (UF360)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.44',1,'T','52C Abnormal (UF255)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.45',1,'T','UPS Control Circuit Error (UF355)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.46',1,'T','AC Input Frequency Out of Range (UA802)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.47',1,'T','Converter Overload (UF056)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.48',1,'T','Cooling Fan Abnormal (UF058)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.49',1,'T','Converter Overtemperature (UF057)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.50',1,'T','UPS Control Circuit Error (UF362)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.51',1,'T','CB2 Opened (DC Voltage Abnormal) (UF161)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.52',1,'T','88C Abnormal (UF254)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.53',1,'T','Converter Abnormal (UF059)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.54',1,'T','Inverter Overload > 100% (UA806)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.55',1,'T','Inverter Overload > 110% (UA807)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.56',1,'T','Inverter Overload > 125% (UA808)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.57',1,'T','Inverter Overload > 150% (UA809)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.58',1,'T','Inverter Overload (UA810)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.59',1,'T','CB1 OFF (UA823)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.60',1,'T','CB2 OFF (UA824)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.61',1,'T','CB101 OFF (UA826)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.62',1,'T','Remote Start Button Abnormal (UA819)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.63',1,'T','Remote Stop Button Abnormal (UA820)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.64',1,'T','Bypass Voltage Out of Range (UA812)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.65',1,'T','Emergency Stop Activated (UA817)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.66',1,'T','52C Not Permitted (UA827)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.67',1,'T','AC Input Phase Rotation Error (UA803)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.68',1,'T','Room Temperature Abnormal (UA805)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.69',1,'T','Converter Start Enable Switch OFF (UA804)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.70',1,'T','AC Input Undervoltage (UA801)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.71',1,'T','Bypass Voltage Out of Range (UA811)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.72',1,'T','Bypass Phase Rotation Error (UA813)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.73',1,'T','Bypass Frequency Out of Range (UA814)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.74',1,'T','Extended Bypass Operation (UA816)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.75',1,'T','Emergency Bypass Switch ON (UA831)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.76',1,'T','Generator Operation (UA822)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.77',1,'T','Interrupted Transfer (UA832)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.78',1,'T','UPS Stopped (Transfer Inhibit) (UA821)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.79',1,'T','UPS Stopped (Transfer Inhibit) (UA835)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.80',1,'T','Inverter Operation (Status1-0)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.81',1,'T','External Alarm (Status1-1)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.82',1,'T','Inverter Running (Status1-2)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.83',1,'T','Inverter S/S (Status1-3)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.84',1,'T','Battery Operation 1 (Status1-4)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.85',1,'T','Battery Low Voltage (Status1-5)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.86',1,'T','Overload (Status1-6)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.87',1,'T','Overload (Level Set)(Status1-7)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.88',1,'T','Enable to Remote (Status1-8)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.89',1,'T','Remote Operation (Status1-9)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.90',1,'T','Battery Depletion (Status1-10)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.91',1,'T','Battery Abnormal(Status1-11)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.92',1,'T','Converter Operation (Status1-12)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.93',1,'T','Battery Operation 2 (Status1-13)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.94',1,'T','CB1 (Status1-14)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.95',1,'T','CB2 (Status1-15)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.96',1,'T','Converter Supply (Status1-16)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.97',1,'T','Battery Operation 3 (Status1-17)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.98',1,'T','52C (Status1-18)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.99',1,'T','AC Input Abnormal (Status1-19)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.100',1,'T','Equalize Charge (Status1-20)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.101',1,'T','Overload (Inverter Stop) (Status1-21)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.102',1,'T','Test Mode (Status1-22)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.103',1,'T','Output Switch Abnormal(Status1-23)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.104',1,'T','CB1 Alarm (Status2-0)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.105',1,'T','CB2 Alarm(Status2-1)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.106',1,'T','52C Alarm (Status2-2)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.107',1,'T','Synchronism (Status3-0)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.108',1,'T','Asynchronism (Status3-1)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.109',1,'T','Voltage Equalize Answer (Status3-2)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.110',1,'T','52S (Status3-5)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.111',1,'T','CB3 (Status3-6)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.112',1,'T','Bypass Operation (Status3-7)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.113',1,'T','Bypass Input Abnormal (Status3-8)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.114',1,'T','Load Supply (Status3-13)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.115',1,'T','Generator Operation (Status3-14)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.116',1,'T','Direction of Battery Current (EX Status 0)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.117',1,'T','Battery Floating (EX Status 1)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.118',1,'T','Power Failure Detection (EX Status 2)');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.119',1,'T','Trap sent when the UPS is supplied by battery.');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.120',1,'T','Trap sent when the automatic battery test is performed.');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9002.0.11',1,'T','MON Trap - deprecated');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.1',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.2',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.122',1,'T','This trap is sent each time an alarm is removed from ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.122',2,'T','the alarm table.  It is sent on the removal of all ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.122',3,'T','alarms except for upsAlarmTestInProgress.');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.121',1,'T','This trap is sent each time an alarm is inserted into ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.121',2,'T','to the alarm table.  It is sent on the insertion of ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.121',3,'T','all alarms except for upsAlarmOnBattery and ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.4030.1.2.0.121',4,'T','upsAlarmTestInProgress.');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.3',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.4',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.5',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.6',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.7',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.8',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.9',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.10',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.11',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.12',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.13',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.14',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.15',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.16',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.17',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.18',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.19',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.20',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.21',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.22',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.23',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.24',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.25',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.26',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.27',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.28',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.29',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.30',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.31',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.32',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.33',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.34',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.35',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.36',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.37',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.38',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.39',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.40',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.41',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.42',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.43',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.44',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.45',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.46',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.47',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.48',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.49',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.50',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.51',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.52',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.53',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.54',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.55',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.56',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.57',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.58',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.59',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.60',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.61',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.62',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.63',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.64',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.65',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.66',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.67',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.68',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.69',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.70',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.71',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.72',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.73',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.74',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.75',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.76',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.77',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.78',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.79',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.80',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.81',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.82',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.83',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.84',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.85',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.86',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.87',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.88',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.89',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.90',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.91',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.92',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.93',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.94',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.95',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.96',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.97',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.98',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.99',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.100',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.101',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.102',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.103',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.104',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.105',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.106',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.107',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.108',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.109',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.110',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.111',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.112',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.113',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.114',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.115',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.116',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.117',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.118',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.119',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.318.0.120',1,'V','.1.3.6.1.4.1.318.2.3.3.0');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1',1,'T','A cHsrpStateChange notification is sent when a ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1',2,'T','cHsrpGrpStandbyState transitions to either active or ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1',3,'T','standby state, or leaves active or standby state. There ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1',4,'T','will be only one notification issued when the state change ');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.9.106.2.0.1',5,'T','is from standby to active and vice versa.');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.0.0',1,'T','CISCO Generic Trap (');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.0.0',2,'S','.1.3.6.1.4.1.9.2.1.2');
INSERT INTO lens_trap_summary_parts VALUES ('.1.3.6.1.4.1.9.0.0',3,'T',')');

#
# Table structure for table 'lens_user'
#

CREATE TABLE lens_user (
  user varchar(32) NOT NULL default '',
  admin int(11) default '0',
  password varchar(32) NOT NULL default '',
  fullname varchar(64) default NULL,
  last_login datetime default NULL,
  last_ip varchar(15) default NULL,
  last_query text NOT NULL,
  PRIMARY KEY  (user)
) TYPE=MyISAM;

#
# Dumping data for table 'lens_user'
#

INSERT INTO lens_user VALUES ('admin',1,'21232f297a57a5a743894a0e4a801fc3','Administrator',NULL,NULL,'DEFAULT');

